/*
 -  S M A P I . H
 -
 *  Purpose:
 *      Header file for Simple MAPI definitions.
 *
 *  Portions copyright 1993-1995 Microsoft Corporation. All Rights Reserved.
 **
 ** Changed strategy for #define portion.
 ** In order to support common mechanism for checking whether GetProcAddress worked,
 ** in Borland and MSVC, would like the name of the function to be the pointer
 ** (as usual).
 ** Thus, the #defines now rename the pointer (and not what it points to), which
 ** will now require the ANSI C feature that fnptr(x) is treated like (*fnptr)(x).
 */

#ifndef SMAPI_H
#define SMAPI_H

#ifndef MAPI_H
#include <mapi.h>
#endif

#ifndef _XCMC_H
#include <xcmc.h>
#endif

extern HINSTANCE    hlibMAPI;

extern LPMAPILOGON lpfnMAPILogon;
extern LPMAPILOGOFF lpfnMAPILogoff;
extern LPMAPISENDMAIL lpfnMAPISendMail;
extern LPMAPISENDDOCUMENTS lpfnMAPISendDocuments;
extern LPMAPIFINDNEXT lpfnMAPIFindNext;
extern LPMAPIREADMAIL lpfnMAPIReadMail;
extern LPMAPISAVEMAIL lpfnMAPISaveMail;
extern LPMAPIDELETEMAIL lpfnMAPIDeleteMail;
extern LPMAPIFREEBUFFER lpfnMAPIFreeBuffer;
extern LPMAPIADDRESS lpfnMAPIAddress;
extern LPMAPIDETAILS lpfnMAPIDetails;
extern LPMAPIRESOLVENAME lpfnMAPIResolveName;

#undef MAPILogon
#undef MAPILogoff
#undef MAPISendMail
#undef MAPISendDocuments
#undef MAPIFindNext
#undef MAPIReadMail
#undef MAPISaveMail
#undef MAPIDeleteMail
#undef MAPIFreeBuffer
#undef MAPIAddress
#undef MAPIDetails
#undef MAPIResolveName

#define MAPILogon           lpfnMAPILogon
#define MAPILogoff          lpfnMAPILogoff
#define MAPISendMail        lpfnMAPISendMail
#define MAPISendDocuments   lpfnMAPISendDocuments
#define MAPIFindNext        lpfnMAPIFindNext
#define MAPIReadMail        lpfnMAPIReadMail
#define MAPISaveMail        lpfnMAPISaveMail
#define MAPIDeleteMail      lpfnMAPIDeleteMail
#define MAPIFreeBuffer      lpfnMAPIFreeBuffer
#define MAPIAddress         lpfnMAPIAddress
#define MAPIDetails         lpfnMAPIDetails
#define MAPIResolveName     lpfnMAPIResolveName

typedef CMC_return_code (FAR PASCAL CMCFREE)(
	CMC_buffer memory
);
typedef CMCFREE FAR *LPCMCFREE;

typedef CMC_return_code (FAR PASCAL CMCSENDDOCUMENTS)(
    CMC_string              recipient_addresses,
    CMC_string              subject,
    CMC_string              text_note,
    CMC_flags               send_doc_flags,
    CMC_string              file_paths,
    CMC_string              file_names,
    CMC_string              delimiter,
    CMC_ui_id               ui_id
);
typedef CMCSENDDOCUMENTS FAR *LPCMCSENDDOCUMENTS;

typedef CMC_return_code (FAR PASCAL CMCLOOKUP)(
    CMC_session_id          session,
    CMC_recipient FAR       *recipient_in,
    CMC_flags               look_up_flags,
    CMC_ui_id               ui_id,
    CMC_uint32 FAR          *count,
    CMC_recipient FAR * FAR *recipient_out,
    CMC_extension FAR       *look_up_extensions
);
typedef CMCLOOKUP FAR *LPCMCLOOKUP;

typedef CMC_return_code (FAR PASCAL CMCLOGON)(
  CMC_string service, CMC_string user, CMC_string password,
  CMC_object_identifier character_set, CMC_ui_id ui_id,
  CMC_uint16 caller_version, CMC_flags flags, CMC_session_id FAR *session,
  CMC_extension FAR *logon_extensions
);
typedef CMCLOGON FAR *LPCMCLOGON;

typedef CMC_return_code (FAR PASCAL CMCQUERYCONFIGURATION)(
  CMC_session_id session, CMC_enum item, CMC_buffer reference,
  CMC_extension FAR *config_extensions
);
typedef CMCQUERYCONFIGURATION FAR *LPCMCQUERYCONFIGURATION;

typedef CMC_return_code (FAR PASCAL CMCLOGOFF)(
  CMC_session_id session, CMC_ui_id ui_id, CMC_flags flags, CMC_extension FAR *extend
);
typedef CMCLOGOFF FAR *LPCMCLOGOFF;

typedef CMC_return_code (FAR PASCAL CMCREAD)(
  CMC_session_id session, CMC_message_reference *msgref, CMC_flags flags,
  CMC_message FAR *FAR *message, CMC_ui_id ui_id, CMC_extension FAR *extend
);
typedef CMCREAD FAR *LPCMCREAD;

typedef CMC_return_code (FAR PASCAL CMCLIST)(
  CMC_session_id session, CMC_string message_type, CMC_flags flags,
  CMC_message_reference *seed, CMC_uint32 FAR *count, CMC_ui_id ui_id,
  CMC_message_summary FAR * FAR *result, CMC_extension FAR *extend
);
typedef CMCLIST FAR *LPCMCLIST;

typedef CMC_return_code (FAR PASCAL CMCACTON)(
  CMC_session_id session, CMC_message_reference *msgref,
  CMC_enum op, CMC_flags flags, CMC_ui_id ui_id, CMC_extension FAR *extend
);
typedef CMCACTON FAR *LPCMCACTON;

extern LPCMCFREE lpfncmc_free;
extern LPCMCSENDDOCUMENTS lpfncmc_send_documents;
extern LPCMCLOOKUP lpfncmc_look_up;
extern LPCMCLOGON  lpfncmc_logon;
extern LPCMCQUERYCONFIGURATION lpfncmc_query_configuration;
extern LPCMCLOGOFF lpfncmc_logoff;
extern LPCMCREAD   lpfncmc_read;
extern LPCMCLIST   lpfncmc_list;
extern LPCMCACTON  lpfncmc_act_on;

#undef cmc_free
#undef cmc_send_documents
#undef cmc_look_up
#undef cmc_logon
#undef cmc_logoff
#undef cmc_read
#undef cmc_list
#undef cmc_act_on
#undef cmc_query_configuration

#define cmc_free                lpfncmc_free
#define cmc_send_documents      lpfncmc_send_documents
#define cmc_look_up             lpfncmc_look_up
#define cmc_logon               lpfncmc_logon
#define cmc_query_configuration lpfncmc_query_configuration
#define cmc_logoff              lpfncmc_logoff
#define cmc_read                lpfncmc_read
#define cmc_list                lpfncmc_list
#define cmc_act_on              lpfncmc_act_on

extern BOOL InitSimpleMAPI(void);
extern void DeinitSimpleMAPI(void);

#endif
