#!/usr/local/bin/wish8.0
# This script will:
#  Load the profile extension
#  Load the mail extension
#  Read the profile ATK.INI to find section Mail entry Sent
#  If the entry does not exist, 
#    A mail message will be prepared and sent to the author (mschwart@nyx.net)
#      noting your success in use of the utility
#    If the mail succeeeds, it will create the Sent entry containing the current date
#  The script will then exit

if [ catch { package require profile } err ] {
  if [ catch { load ./profile.dll } err ] {
    # "Null out" the profile package
    proc profile { args } { return "Never" }
  }
}

if [ catch { package require mapimail } err ] {
  if [ catch { load ./mapimail.dll } err ] {
    error "Can't load mapimail: $err"
  }
}

set sentmail [ profile get -private atk.ini -section Mail -key Sent -default Never ]

wm withdraw .
if { "$sentmail" == "Never" } {
  set curdate [ clock format [clock seconds] ]

  if [ catch {
          mapimail send -to mschwart@nyx.net -subject "Running profile and mapimail!" \
          -body "Loaded at $curdate and running fine!"
             } err ] {
    error "Couldn't send mail: $err"
  }

  profile set -private atk.ini -section Mail -key Sent -value $curdate

  tk_dialog .done "Success!" "Successfully completed test of profile and mapimail" \
	  info 0 OK
} else {
  tk_dialog .done "Success!" \
                  "Successfully completed test of profile; \
		   mapimail test skipped--previously completed $sentmail" \
	  info 0 OK
}

exit 0
